﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;

namespace DocIOApplication.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(string button1, string Message)
        {
            if (button1 == null)
                return View();

            //Creates an instance of WordDocument Instance (Empty Word Document)
            WordDocument wordDocument = new WordDocument();
            //Add a section & a paragraph in the empty document
            wordDocument.EnsureMinimal();

            //Adds a new paragraph style named "MyStyle" 
            IWParagraphStyle myStyle = wordDocument.AddParagraphStyle("MyStyle");
            //Sets the formattings of the style 
            myStyle.CharacterFormat.FontName = "Arial";
            myStyle.CharacterFormat.FontSize = 17f;

            //Adds a table into the Word document
            WTable wTable = wordDocument.LastSection.AddTable() as WTable;
            //Creates the specified number of rows and columns
            wTable.ResetCells(3, 2);

            int value_y = 2, value_x = 1;
            // Add content to table cells.
            wTable[value_y - 2, value_x - 1].AddParagraph().AppendText("bla");
            // Apply formatting for content of table cell.
            ApplyFormattingForCellContent(wTable[value_y - 2, value_x - 1]);
            wTable[value_y - 2, value_x].AddParagraph().AppendText("bla");
            ApplyFormattingForCellContent(wTable[value_y - 2, value_x]);
            wTable[value_y - 1, value_x - 1].AddParagraph().AppendText("bla");
            ApplyFormattingForCellContent(wTable[value_y - 1, value_x - 1]);
            wTable[value_y - 1, value_x].AddParagraph().AppendText("bla");
            ApplyFormattingForCellContent(wTable[value_y - 1, value_x]);
            wTable[value_y, value_x - 1].AddParagraph().AppendText("bla");
            ApplyFormattingForCellContent(wTable[value_y, value_x - 1]);
            wTable[value_y, value_x].AddParagraph().AppendText("bla");
            ApplyFormattingForCellContent(wTable[value_y, value_x]);

            #region Document Save
            MemoryStream memoryStream = new MemoryStream();
            wordDocument.Save(memoryStream, FormatType.Docx);
            memoryStream.Position = 0;
            //Setting HTTP content Type 
            string strContentType = "application/ms-word";
            //Display type
            string strDispType = "attachment";
            //Adding information to the header
            Response.AddHeader("Content-Type", strContentType);
            Response.AddHeader("Content-Disposition", string.Format("{0};filename={1};", strDispType, "Sample.docx"));
            memoryStream.CopyTo(Response.OutputStream);
            memoryStream.Dispose();
            Response.End();
            #endregion Document Save
            return View();
        }
        /// <summary>
        /// Apply Formatting to contents of table cell.
        /// </summary>
        /// <param name="wTableCell">The Table Cell</param>
        private void ApplyFormattingForCellContent(WTableCell wTableCell)
        {
            foreach (Entity entity in wTableCell.ChildEntities)
            {
                if (entity is WTable)
                {
                    WTable wTable = entity as WTable;
                    foreach (WTableRow tableRow in wTable.Rows)
                        foreach (WTableCell tableCell in tableRow.Cells)
                            ApplyFormattingForCellContent(tableCell);
                }
                else if (entity is WParagraph)
                    (entity as WParagraph).ApplyStyle("MyStyle");
            }
        }
    }
}